//+------------------------------------------------------------------+
//| ADX Crossing.mq4                                                 +
//| Author: Amir                                                     +
//| 20070623 - Modified by HerbertH (Add MPower rules filter, Alerts)+
//+------------------------------------------------------------------+
//mod di x adx 
#property  copyright "Author - Amir"

#property indicator_chart_window
#property indicator_buffers      2
#property indicator_width1       0
#property indicator_width2       0
#property indicator_color1       DeepSkyBlue
#property indicator_color2       Tomato

extern int     ADX_period          =  14;
extern int     DI_period           =  14;

//extern int     ADX_period           =  14;
extern int     adxLevel          =  20;
extern int     MaxBars           =  1000;
extern bool    showAllcrosses    =  false;
extern bool    UseAlert          =  false;

double   val1[],
         val2[],
         b4plusdi,
         nowplusdi,
         b4minusdi,
         nowminusdi,
         ADX0,
         ADX1;
bool     CrossUp,
         CrossDown;
string   AlertTXT;
datetime AlertBar,
         LastAlertBar;


int init()
{
   string short_name;
   IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,233);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,234);
   SetIndexBuffer(0,val1);
   SetIndexBuffer(1,val2);
   return(0);
}


int start()
{   
   if (MaxBars>=Bars) MaxBars=Bars;
   SetIndexDrawBegin(0,Bars-MaxBars);
   SetIndexDrawBegin(1,Bars-MaxBars);
   int i,shift,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);

   if(counted_bars<1)
   {
      for(i=1;i<=MaxBars;i++) val1[MaxBars-i]=0.0;
      for(i=1;i<=MaxBars;i++) val2[MaxBars-i]=0.0;
   } 

   CrossDown = false;
   CrossUp   = false;

   for (shift = MaxBars; shift>=0; shift--) 
   {
      b4plusdi    = iADX(NULL,0,DI_period,PRICE_CLOSE,MODE_PLUSDI,shift+1);
      nowplusdi   = iADX(NULL,0,DI_period,PRICE_CLOSE,MODE_PLUSDI,shift);
      b4minusdi   = iADX(NULL,0,DI_period,PRICE_CLOSE,MODE_MINUSDI,shift+1);
      nowminusdi  = iADX(NULL,0,DI_period,PRICE_CLOSE,MODE_MINUSDI,shift);
      ADX1        = iADX(NULL,0,ADX_period,PRICE_CLOSE,MODE_MAIN,shift+1);
      ADX0        = iADX(NULL,0,ADX_period,PRICE_CLOSE,MODE_MAIN,shift);

   val1[shift]=EMPTY_VALUE;   val2[shift]=EMPTY_VALUE;


   if ( (ADX1<adxLevel||b4plusdi<adxLevel||b4plusdi<ADX1) && 
         nowplusdi>b4plusdi && nowplusdi>ADX0   && ADX0>adxLevel  && ADX0>ADX1   )
     
         {
            val1[shift] = Low[shift]-10*Point;
            CrossUp     = false;
            AlertTXT    = " DI x ADX UP ";
            AlertBar    = Time[0];
         }



   
   if(   (ADX1<adxLevel||b4minusdi<adxLevel||b4minusdi<ADX1) && 
          nowminusdi>b4minusdi &&   nowminusdi>ADX0 && ADX0>adxLevel && ADX0>ADX1 ) 

         {
            val2[shift] = High[shift]+10*Point;
            CrossDown   = false;
            AlertTXT    = " DI x ADX DN ";
            AlertBar    = Time[0];
         }
   }

   if(UseAlert && LastAlertBar!=AlertBar)
      {
         Alert(Symbol(), ",", Period(), AlertTXT);
         LastAlertBar=AlertBar;
      }

   return(0);
}